////////////////////////////////////////////////////////////////////////////////////
///                                                                              ///
///          BIBLIOTHÈQUE DE SAGESSE ET DE RÉFLEXION par JÉRÉMY MAURICE          ///
///                                                                              ///
////////////////////////////////////////////////////////////////////////////////////
///                                                                              ///
///    SE PLACER DEVANT LE SONAR POUR ACTIVER LE LECTURE DES EXTRAITS AUDIOS     ///
///       SORTIR DE LA ZONE DE DÉTECTION POUR METTRE EN PAUSE LES EXTRAITS       ///
///    REVENIR DEVANT LE SONAR POUR POURSUIVRE LA LECTURE AUDIO DES EXTRAITS     ///
///                                                                              ///
////////////////////////////////////////////////////////////////////////////////////

/// L'ENSEMBLE A ÉTÉ RÉALISÉ SUR PROCESSING VERSION 3.0.1 : À TÉLÉCHARGER SUR MAC \\\

/// Librairies à télécharger et à importer pour le fonctionnement du code \\\
import cc.arduino.*;        /// Pour les fonctionnalités arduino \\\
import processing.serial.*; /// Pour le port de communication entre l'arduino et lE Mac \\\
import ddf.minim.*;         /// Pour faire jouer le son \\\

/// Variables utilisées
int           gMax            = 81;                /// Quantité d'extraits audio modifiable en fonction \\\
int[]         gTabRandom      = new int[gMax];     /// Maximum d'extraits audios dans le tableau \\\
int           gMaxTabRandom   = gTabRandom.length; /// Longueur du tableau \\\
int           gidx            = 0;                 /// L'extrait audio en train de jouer \\\
int           gCountFilm      = 0;                 /// Nombre d'extraits audio joués \\\
int           delaiHorsLimite = 1000;              /// Temps avant la pause une fois hors limite (1000 = 1 seconde) \\\                                                       
int           distancePouces  = 1;                 /// Valeur par défaut en pouces \\\                                              
int           distanceCm      = 1;                 /// Valeur par défaut en cm \\\
long          i               = 0;                 /// Variable \\\
boolean       gbPause         = false;             /// Boolean pour la pause : faux par défaut \\\
String[]      gFilms          = new String[gMax];  /// Nom de l'extrait audio \\\
String        data;                                /// Données de la distance reçues du sonar \\\
Serial        gMyPort;                             /// Port de connexion arduino \\\
AudioPlayer[] gTabFilmPlayer;                      /// Lecteur audio utilisé ici pour le code en processing \\\

/// Nommer les fonctions qui seront utilisées plus bas \\\
void setup() 
  { frameRate(1);
    background(0);
    initArduinoSettings();
    initTabRandom(); 
    initTabFilm();
    construireTabRandom();
    construireEtJouerFilmsRandom(); }

/// Énumération de tous les ports possible des ports Apple \\\
void initArduinoSettings() 
  { gMyPort = new Serial(this,Serial.list()[2],9600); 
    println(Serial.list()[2]);
    gMyPort.bufferUntil(10); }

/// Initialiser le tableau aléatoire séquentielement \\\
void initTabRandom() 
  { for(int i = 0; i < gMaxTabRandom; i++)
    { gTabRandom[i] = i; } }

/// Films qui seront joués : gFilms[gMax] (gMax : comprend entre 0 et le nombre total de film -1) = associé aux noms des fichiers audios \\\
void initTabFilm() 
  { gFilms[ 0] =                                     "AMERICAN-DAD.mp3";
    gFilms[ 1] =                                           "AVATAR.mp3";
    gFilms[ 2] =                             "BLADE-RUNNER-2049-01.mp3";
    gFilms[ 3] =                             "BLADE-RUNNER-2049-02.mp3";
    gFilms[ 4] =                             "BLADE-RUNNER-2049-03.mp3";
    gFilms[ 5] =                                       "BLEACH-289.mp3";
    gFilms[ 6] =                                       "BLEACH-292.mp3";
    gFilms[ 7] =                                    "BLOOD-DIAMOND.mp3";
    gFilms[ 8] =                                   "BREAKFAST-CLUB.mp3";
    gFilms[ 9] =                                    "CHACUN-SA-VIE.mp3";
    gFilms[10] =                                        "DARK-CITY.mp3";
    gFilms[11] =                                          "DUNE-01.mp3";
    gFilms[12] =                                          "DUNE-02.mp3";
    gFilms[13] =                                          "DUNE-03.mp3";
    gFilms[14] =                                     "ENTRE-HOMMES.mp3";
    gFilms[15] =                                   "FOREST-GUMP-01.mp3";
    gFilms[16] =                                   "FOREST-GUMP-02.mp3";
    gFilms[17] =                                   "FOREST-GUMP-03.mp3";
    gFilms[18] =                                   "FOREST-GUMP-04.mp3";
    gFilms[19] =                                   "FOREST-GUMP-05.mp3";
    gFilms[20] =                          "GHOST-IN-THE-SHELL-I-01.mp3";
    gFilms[21] =                          "GHOST-IN-THE-SHELL-I-02.mp3";
    gFilms[22] =                         "GHOST-IN-THE-SHELL-II-01.mp3";
    gFilms[23] =                         "GHOST-IN-THE-SHELL-II-02.mp3";
    gFilms[24] =                         "GHOST-IN-THE-SHELL-II-03.mp3";
    gFilms[25] =                                   "HARRY POTTER V.mp3";
    gFilms[26] = "IL-Y-A-DES-JOURS...-ET-DES-LUNES-_BANDE-ANNONCE_.mp3";
    gFilms[27] =              "JE-SUIS-TIMIDE-MAIS-JE-ME-SOIGNE-01.mp3";
    gFilms[28] =              "JE-SUIS-TIMIDE-MAIS-JE-ME-SOIGNE-02.mp3";
    gFilms[29] =              "JE-SUIS-TIMIDE-MAIS-JE-ME-SOIGNE-03.mp3";
    gFilms[30] =                                      "KILL-BILL-I.mp3";
    gFilms[31] =                         "KIRIKOU-ET-LA-SOCIÈRE-01.mp3";
    gFilms[32] =                         "KIRIKOU-ET-LA-SOCIÈRE-02.mp3";
    gFilms[33] =                              "L_HISTOIRE-SANS-FIN.mp3";
    gFilms[34] =                                "LA-BELLE-HISTOIRE.mp3";
    gFilms[35] =                                   "LA-TOUR-SOMBRE.mp3";
    gFilms[36] =                  "LE-CONTE-DE-LA-PRINCESSE-KAGUYA.mp3";
    gFilms[37] =                                     "LE-DICTATEUR.mp3";
    gFilms[38] =                             "LE-GARÇON-ET-LA-BÊTE.mp3";
    gFilms[39] =                                 "LE-GRAND-BLEU-01.mp3";
    gFilms[40] =                                 "LE-GRAND-BLEU-02.mp3";
    gFilms[41] =                        "LE-SEIGNEUR-DES-ANNEAUX-I.mp3";
    gFilms[42] =                           "LE-SYNDROME-DE-WILLIAM.mp3";
    gFilms[43] =                            "LES-AILES-DU-DÉSIR-01.mp3";
    gFilms[44] =                            "LES-AILES-DU-DÉSIR-02.mp3";
    gFilms[45] =                     "LES-STATUES-MEURENT-AUSSI-01.mp3";
    gFilms[46] =                     "LES-STATUES-MEURENT-AUSSI-02.mp3";
    gFilms[47] =                                    "LITTLE-BUDDHA.mp3";
    gFilms[48] =                                          "LUCY-01.mp3";
    gFilms[49] =                                          "LUCY-02.mp3";
    gFilms[50] =                                      "MATRIX-I-01.mp3";
    gFilms[51] =                                      "MATRIX-I-02.mp3";
    gFilms[52] =                                  "MATRIX-RELOADED.mp3";
    gFilms[53] =                                 "MESSAGER-DE-DIEU.mp3";
    gFilms[54] =                                      "MUSHISHI-01.mp3";
    gFilms[55] =                                        "OVERWATCH.mp3";
    gFilms[56] =                           "PIRATES-DES-CARAÏBES-I.mp3";
    gFilms[57] =                            "PRINCESSE-MONONOKE-01.mp3";
    gFilms[58] =                            "PRINCESSE-MONONOKE-02.mp3";
    gFilms[59] =                                      "RUSH-HOUR-3.mp3";
    gFilms[60] =                              "SAMURAI-CHAMPLOO-25.mp3";
    gFilms[61] =                                      "STAR-WARS-I.mp3";
    gFilms[62] =                                         "STARGATE.mp3";
    gFilms[63] =                                  "TERMINATOR-2-01.mp3";
    gFilms[64] =                                  "TERMINATOR-2-02.mp3";
    gFilms[65] =                               "THE-GRANDMASTER-01.mp3";
    gFilms[66] =                                   "TRUMAN-SHOW-01.mp3";
    gFilms[67] =                                   "TRUMAN-SHOW-02.mp3";
    gFilms[68] =                    "UN-RACCOURCI-DANS-LE-TEMPS-01.mp3";
    gFilms[69] =                    "UN-RACCOURCI-DANS-LE-TEMPS-02.mp3";
    gFilms[70] =                                        "WEST-WING.mp3";
    gFilms[71] =                                          "X-FILES.mp3";
    gFilms[72] = "COMMENT-LES-ENFANTS-VOIENT-ILS-LE-MONDE-DES-A-01.mp3"; 
    gFilms[73] = "COMMENT-LES-ENFANTS-VOIENT-ILS-LE-MONDE-DES-A-02.mp3";
    gFilms[74] =                                           "INDICE.mp3"; 
    gFilms[75] =                          "JONATHAN-LIVINGSTONE-01.mp3"; 
    gFilms[76] =                          "JONATHAN-LIVINGSTONE-02.mp3";
    gFilms[77] =                          "JONATHAN-LIVINGSTONE-03.mp3";
    gFilms[78] =                       "LE-SEIGNEUR-DES-ANNEAUX-II.mp3";
    gFilms[79] =                              "SAMURAI-CHAMPLOO-02.mp3";
    gFilms[80] =                                  "V-POUR-VANDETTA.mp3"; }

/// Construire le tableau aléatoire \\\
void construireTabRandom()  
{ int lidx = 0;
  int temp = 0;
    for(int i = 0; i < gMaxTabRandom; i++) 
      { lidx             = (int)random(0,gMax - 1);
        temp             = gTabRandom[i];
        gTabRandom[i]    = gTabRandom[lidx]; 
        gTabRandom[lidx] = temp; } }

/// Chercher l'extrait audio dans le tableau random et le faire jouer \\\
void construireEtJouerFilmsRandom()
  { String sFileFilm; 
    Minim mini     = new Minim(this); 
    gTabFilmPlayer = new AudioPlayer[gMaxTabRandom]; 
      for(int i = 0; i < gMaxTabRandom; i++)
        { sFileFilm = gFilms[gTabRandom[i]]; 
          gTabFilmPlayer[i] = mini.loadFile(sFileFilm); }
          gCountFilm     = 1; 
          distancePouces = 50; 
          gTabFilmPlayer[gidx].play();
          println(gCountFilm + " / " + gMax + " : " + gFilms[gTabRandom[gidx]]);
            if(gTabFilmPlayer[gidx].isPlaying())
              { gbPause = false; } }

/// Continuer la lecture des extraits audio, faire la pause ou recommencer la lecture audio aléatoire \\\
void draw()
  { if(gbPause == false) 
    { if(gTabFilmPlayer[gidx].isPlaying())
      { }
        else if(gTabFilmPlayer[gidx].isPlaying() == false) 
          { println("\n");
            gCountFilm = gCountFilm + 1; 
            gidx       = gidx + 1;
              if(gidx == gMax) 
                { println("Nouvelle lecture");
                  initTabRandom(); 
                  construireTabRandom(); 
                  gidx = 0; 
                  construireEtJouerFilmsRandom(); }
                    else 
                      { gTabFilmPlayer[gidx].play();
                        println(gCountFilm + " / " + gMax + " : " + gFilms[gTabRandom[gidx]]); } } 
                          else
                            { } } }

/// Détection par arduino pour le sonar \\\
void serialEvent(Serial gMyPort)
  { data = gMyPort.readStringUntil(10);
    if(data != null) 
      { if((i % 10) == 0) 
        { data = trim(data); 
          data = data.replace("in","");
          data = data.replace("cm","");
          data = trim(data);
          int values[] = int(split(data,","));
            if(values.length > 0) 
              { distancePouces = values[0];
                distanceCm     = values[1]; } 
                  if(distancePouces > 0 && distancePouces <= 48) 
                    { gTabFilmPlayer[gidx].play(); 
                      println(distancePouces + " pouces : En train de jouer"); 
                      gbPause = false; }
                        else { delay(delaiHorsLimite); 
                                 if(gTabFilmPlayer[gidx].isPlaying()) 
                                   { gTabFilmPlayer[gidx].pause();
                                     gbPause = true;
                                     println(distancePouces + " pouces : En pause"); } } } 
                                       i = i + 1; } }